<TeXmacs|1.0.3.9>

<style|article>

<\body>
  <\make-title>
    <title|Gomtrie et Programmation Scheme avec Dr. Geo>

    <author|Andrea Centomo>

    <\address>
      Organization for Free Software in Education and Teaching
    </address>

    <title-email|acentomo@ofset.org>

    <title-date|<date><made-by-TeXmacs>>
  </make-title>

  <\abstract>
    One of the most peculiar aspects of Dr. Geo is related to the presence of
    a powerful programming ambient strongly connected to its geometrical
    engine. In this paper, after a brief introduction to the concept of
    Scheme Figure, we present an easy example of iterative figure with some
    generalizations. \ 
  </abstract>

  La forte intgration qu'on trouve dans le logiciel de gomtrie interactive
  Dr. Geo entre les outils avancs de programmation - langage Guile/Scheme -
  et le moteur pour la manipulation d'objects gomtriques, ouvre de
  nouvelles perspectives pour la didactique des mathmatiques  diffrents
  niveaux, dans un horizon qui s'tend de l'cole secondaire de premier degr
  jusqu' l'cole de duxime degr.

  Nous ne sommes pas encore  mme d'offrir un devloppement systmatique et
  exhaustif  propos des possibilits didactiques relatives  ce marriage
  entre programmation et gomtrie et, nous procderons, donc, en analysant
  seulement certains exemples d'emploi relatifs aux figures interactives.

  L'ide d'exploiter des structures interactives mises  disposition par le
  langage de haut niveau Scheme reprsente l'exemple, le plus naturel,
  d'articulation entra gomtrie et programmation. Cet exemple est
  certainement connu par tous ceux qui connaissent le langage Logo. D'autres
  possibles domaines d'application, moins vidents, pourraient tre lis 
  l'tude de la thorie de la probabilit.

  <section|Figures Scheme de Dr. Geo>

  Les <strong|Figures Scheme de Dr. Geo> -- <acronym|fsd> -- sont des figures
  crites dans un langage relativement naturel. Il ne s'agit donc plus de
  construire une figure  l'aide de l'interface graphique de Dr. Geo mais
  plutt de dcrire une figure dans le langage Scheme. Nous avons apport le
  plus grand soin afin que la syntaxe utilise soit facile et lgre. Aussi
  l'ensemble des mots cls utiliss pour dcrire une figure simple sont
  adaptables dans diffrentes langues. Ainsi une figure pourra tre dcrite
  en Franais, en Anglais, en Espagnol, etc. Un mlange de langues est mme
  possible mais ce n'est pas souhaitable.

  <subsection|Exemples base>

  En lui mme Scheme est un langage de trs haut niveau, lorsqu'une figure
  est dfinie dans ce langage, nous disposons galement de toute sa puissance
  pour par exemple dfinir rcursivement telle partie de la figure, ou bien
  pour placer alatoirement certains objets de telle sorte qu' chaque
  ouverture de la figure, celle-ci est lgrement diffrente. Bref, les
  <acronym|fsd> sont libres du carcan de l'interface graphique tout en
  tant renforcs du langage Scheme. Une <acronym|fsd> est donc un fichier
  cr  l'aide d'un diteur de texte, il est ensuite ouvert dans Dr. Geo 
  l'aide de la commande <samp|Fichier><with|mode|math|\<rightarrow\>><samp|valuer>.

  Commenons par tudier un exemple simple de <acronym|fsd> :

  <\code>
    (new-figure "Figura")\ 

    (lets Point "A" free 2 -2)
  </code>

  Cette <acronym|fsd> dfinie une figure avec un point libre
  <with|mode|math|A> de coordonnes initiales <with|mode|math|(2;-2)>. Comme
  nous pouvons le voir la syntaxe de dfinition d'un objet gomtrique est
  relativement agrable, d'autant plus qu'elle est exprime dans une langue
  maternelle. Intressons nous de plus prs  la deuxime instruction, en
  effet celle-ci suit une syntaxe qui est commune  toutes les commandes de
  dfinition d'objet. Ce type de commande se dcompose comme suit :

  <\enumerate-alpha>
    <item>Elle commence toujours par le mot-cl <verbatim|lets>, il indique
    que nous souhaitons dfinir un nouvel objet.

    <item>Il est immdiatement suivi de la catgorie de l'objet, ici
    <verbatim|Point>.

    <item>Le nom de l'objet vient ensuite, <verbatim|A>, il doit toujours
    tre entour de ". Si nous ne souhaitons pas nommer l'objet, il faut tout
    de mme donner un nom vide comme suit: "".

    <item>Enfin, nous prcisons le type de l'objet -- le type de point dans
    notre exemple -- ici <verbatim|free>. Cela signifie que le point
    <with|mode|math|A> est libre.

    <item>Le type de l'objet est suivit d'une liste d'argument spcifique.
    Dans notre exemple cette liste est compose de deux nombres, les
    coordonnes du point libre <with|mode|math|A>.
  </enumerate-alpha>

  Poursuivons avec un autre exemple :

  <\code>
    (define (triangle p1 p2 p3)\ 

    (Segment "" extremities p1 p2)\ 

    (Segment "" extremities p2 p3)\ 

    (Segment "" extremities p1 p3))

    \;

    (define (rand) (- 8 (* 16 (random:uniform))))

    \;

    (new-figure "Exemple")

    (lets Point "A" free (rand) 0)\ 

    (lets Point "B" free 5 0)\ 

    (lets Point "C" free (rand) 5)

    (triangle A B C)
  </code>

  Cet exemple est particulirement intressant, il nous montre trois choses
  importantes :

  <\enumerate-numeric>
    <item>L'introduction de construction de plus haut niveau, non prvue au
    dpart par Dr. Geo. Ici nous avons dfini la fonction <verbatim|triangle>
    qui,  partir de trois points, construit le triangle passant par ces
    trois points. Nous pouvons comparer ceci avec les macro-constructions
    mais avec un degr de libert beaucoup plus important.

    <item>La dfinition de fonctions associes, ici nous avons dfini la
    fonction <verbatim|rand> qui retourne un nombre dcimal compris entre -8
    et 8. Nous utilisons cette fonction pour placer au hasard certains points
    de notre figure, ainsi  chaque ouverture la figure est lgrement
    diffrente.

    <item>En fait l'utilisation du mot cl <verbatim|lets> n'est pas
    obligatoire, nous l'utilisons lorsque nous souhaitons garder une
    rfrence de l'objet cr. Par exemple dans la fonction
    <verbatim|triangle>, nous ne gardons pas de rfrences des segments
    crs, en revanche lorsque nous dfinissons nos points
    <with|mode|math|A>, <with|mode|math|B> et <with|mode|math|C> nous avons
    besoin de garder une rfrence, ces rfrences ont le mme nom<\footnote>
      D'un point de vue interne au langage Scheme, ces rfrences sont des
      symboles pointant sur une strucuture interne de l'objet -- un prototype
      -- alors que les noms sont des chanes de caractres.
    </footnote> sans guillemet : <verbatim|A>, <verbatim|B> et <verbatim|C>.
    Dans la suite nous appellerons <strong|symbole> ces rfrences, c'est la
    terminologie exacte du langage Scheme. Ainsi, lors de l'appel de la
    fonction <verbatim|triangle>, nous passons en paramtre les symboles
    <verbatim|A>, <verbatim|B> et <verbatim|C> qui sont utiliss pour dfinir
    nos trois segments.
  </enumerate-numeric>

  \ 

  Noter que lors de la dfinition des segments, nous ne donnons pas de nom,
  dans ce cas Dr. Geo va attribuer un nom par dfaut dfini  partir du nom
  des extrmits. Nos trois segments auront donc comme nom
  <with|mode|math|[AB]>, <with|mode|math|[BC]> et <with|mode|math|[AC]>.

  Pour clure cette section, voici un dernier exemple :

  <\code>
    (new-figure "Send")

    \;

    (lets Point "A" free 1 0)\ 

    (lets Point "B" free 2 0)\ 

    (lets Point "C" free 2 0)

    \;

    (lets Line "d1" 2points A B)

    \;

    (send A color yellow)\ 

    (send A shape round)\ 

    (send A size large)

    \;

    (send B color green)

    \;

    (send C masked)

    \;

    (send d1 thickness dashed)
  </code>

  Les trois premires commandes crent deux points et une droite. La partie
  qui nous intresse plus particulirement est la srie de commande
  <verbatim|send>. Cette commande permet de communiquer avec un objet dont
  nous avons gard un symbole, ici nous avons les symboles <verbatim|A>,
  <verbatim|B>, <verbatim|C> et <verbatim|d1>. Elle consiste  envoyer un
  message  un objet, son premier argument est l'objet avec lequel nous
  communiquons, le deuxime argument le message, le troisime et les suivants
  sont dtermins par la nature du message. Par exemple <verbatim|(send A
  color yellow)> envoi le message <verbatim|color> avec comme paramtre
  <verbatim|yellow>, le point A est peint en jaune. Il est assez facile de
  comprendre le sens des autres commandes <verbatim|send>.

  <subsection|Figures Scheme Iteratives>

  Un premier exemple est reprsent par la figure :

  <big-figure|<postscript|spitri.ps|*5/8|||||>|Base>

  Le code Scheme qui permet de la fixer est le suivant :

  <\code>
    (new-figure "Base")

    \;

    (define (triangle p1 p2 p3 n)

    \ \ 

    \ \ (let* ((s1 (Segment "" extremities p1 p2))

    \ \ \ \ \ \ \ \ \ (s2 (Segment "" extremities p2 p3))

    \ \ \ \ \ \ \ \ \ (s3 (Segment "" extremities p3 p1))

    \ \ \ \ \ \ \ \ \ (A \ (Point "" on-curve s1 1/10))

    \ \ \ \ \ \ \ \ \ (B \ (Point "" on-curve s2 1/10))

    \ \ \ \ \ \ \ \ \ (C \ (Point "" on-curve s3 1/10)))

    \;

    \ \ \ \ \ \ \ \ \ (send A masked)

    \ \ \ \ \ \ \ \ \ (send B masked)

    \ \ \ \ \ \ \ \ \ (send C masked)

    \ \ \ \ \ \ \ \ \ 

    \ \ \ \ \ \ \ \ \ (if (\<gtr\> n 0)

    \ \ \ \ \ \ \ \ \ \ \ \ \ 

    \ \ \ \ \ \ \ \ \ \ \ \ \ (triangle A B C (- n 1)))))

    \;

    (lets Point "L" free -5 0)\ 

    (lets Point "M" free \ 5 0)

    (lets Point "N" free \ 0 ( * 5 (sqrt 3)))

    \;

    (triangle L M N 20)
  </code>

  Ici nous avons utiliss la fonction <verbatim|triangle> qui,  partir de
  trois points, construit le triangle passant par ces trois points. Un petit
  cycle est suffisant pour obtenir la figure  partir de <with|mode|math|L M
  N>.

  <\problem>
    Construire une analoge <acronym|fsd>  partir de <with|mode|math|ABCD> o
    le polygone <with|mode|math|ABCD> est un carr.
  </problem>

  La solution est donne par le code Scheme :

  <\code>
    (new-figure "General")

    \;

    (define (carre p1 p2 p3 p4 n)

    \ \ 

    \ \ (let* ((s1 (Segment "" extremities p1 p2))

    \ \ \ \ \ \ \ \ \ (s2 (Segment "" extremities p2 p3))

    \ \ \ \ \ \ \ \ \ (s3 (Segment "" extremities p3 p4))

    \ \ \ \ \ \ \ \ \ (s4 (Segment "" extremities p4 p1))

    \ \ \ \ \ \ \ \ \ (A \ (Point "" on-curve s1 1/10))

    \ \ \ \ \ \ \ \ \ (B \ (Point "" on-curve s2 1/10))

    \ \ \ \ \ \ \ \ \ (C \ (Point "" on-curve s3 1/10))

    \ \ \ \ \ \ \ \ \ (D \ (Point "" on-curve s4 1/10)))

    \;

    \ \ \ \ \ \ \ \ \ (send A masked)

    \ \ \ \ \ \ \ \ \ (send B masked)

    \ \ \ \ \ \ \ \ \ (send C masked)

    \ \ \ \ \ \ \ \ \ (send D masked)

    \ \ \ \ \ \ \ \ \ 

    \ \ \ \ \ \ \ \ \ (if (\<gtr\> n 0)

    \ \ \ \ \ \ \ \ \ \ \ \ \ 

    \ \ \ \ \ \ \ \ \ \ \ \ \ (carre A B C D (- n 1)))))

    \;

    (lets Point "A" free \ 5 \ 5)\ 

    (lets Point "B" free -5 \ 5)

    (lets Point "C" free -5 -5)

    (lets Point "D" free \ 5 -5)

    \;

    (carre A B C D 30)
  </code>

  La figure est :

  <big-figure|<postscript|spicar.ps|*5/8|||||>|Generalization>

  <section*|Bibliographie>

  [1] H. Fernandes, <em|Manuel utilisateur de Dr. Geo>, Ofset, 2004.
</body>

<\initial>
  <\collection>
    <associate|language|french>
  </collection>
</initial>

<\references>
  <\collection>
    <associate|auto-1|<tuple|1|1>>
    <associate|auto-2|<tuple|1.1|1>>
    <associate|auto-3|<tuple|1.2|3>>
    <associate|auto-4|<tuple|1|3>>
    <associate|auto-5|<tuple|2|5>>
    <associate|auto-6|<tuple|2|5>>
    <associate|footnote-1|<tuple|1|2>>
  </collection>
</references>

<\auxiliary>
  <\collection>
    <\associate|figure>
      <tuple|normal|Base|<pageref|auto-4>>

      <tuple|normal|Generalization|<pageref|auto-5>>
    </associate>
    <\associate|toc>
      <vspace*|1fn><with|font-series|<quote|bold>|math-font-series|<quote|bold>|1<space|2spc>Figures
      Scheme de Dr. Geo> <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <pageref|auto-1><vspace|0.5fn>

      <with|par-left|<quote|1.5fn>|1.1<space|2spc>Exemples base
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <pageref|auto-2>>

      <with|par-left|<quote|1.5fn>|1.2<space|2spc>Figures Scheme Iteratives
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <pageref|auto-3>>

      <vspace*|1fn><with|font-series|<quote|bold>|math-font-series|<quote|bold>|Bibliographie>
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <pageref|auto-6><vspace|0.5fn>
    </associate>
  </collection>
</auxiliary>